<template>
  <Filter @update="search" @search="updateColumn"></Filter>
  <!-- 库存报表(仓库) -->
  <mtp-table-scroll>
    <template #default="{ scroll }">
      <a-table :columns="columns" class="srcollYTable" :scroll="scroll" :pagination="false" :rowClassName="rowClassName"
        :expandedRowKeys="expandedRowKeys" :customRow="Rowclick" :rowKey="(record, index) => index"
        :data-source="tableList"> </a-table>
    </template>
  </mtp-table-scroll>
  <!-- 明细 -->
  <mtp-table-detail :columns="columnsDetail" :data-source="detailTableList" :tabs="tabList" v-model:visible="visible"
    @change="changeTab" />
</template>

<script lang="ts">
import MtpTableScroll from '@/common/components/tableScroll/index.vue';
import Filter from '../../components/filterTable/index.vue';
import { defineComponent, queryTableList } from '@/common/export/table';
import { ComposeTableDetailParam, handleComposeTable_detail } from '@/common/setup/table/compose';
import { ref, watch } from 'vue';
import { queryResultLoadingAndInfo } from '@/common/methods/request/resultInfo';
import { handleInitTypeAndTime } from '@/views/report/setup';
import { qryAreaStockReport } from '@/services/go/ermcp/report';
import { AreaStockReportReq, Ermcp3AreaStockReport } from '@/services/go/ermcp/report/interface';
import { TypeAndTime } from '@/views/report/interface';
import { EnumRouterName } from '@/common/constants/enumRouterName';
import { getTableButton } from '@/common/setup/table/button';
import MtpTableDetail from '@/common/components/tableDetail/index.vue';

export default defineComponent({
  name: 'inventory_report_warehouse',
  components: {
    MtpTableScroll,
    Filter,
    MtpTableDetail,
  },
  setup() {
    let cycletime = '';
    // 表格列表数据
    const { loading, tableList, queryTable } = queryTableList<Ermcp3AreaStockReport>();
    // 控制明细显示/隐藏
    const visible = ref(true);
    // 获取列表数据
    const queryTableAction = () => {
      const { getInitTime, getInitType } = handleInitTypeAndTime();
      cycletime = getInitTime();
      const param: AreaStockReportReq = {
        cycletype: getInitType(),
        cycletime,
        querytype: 1,
        sumfields: '1,2,4',
      };
      // 获取列表数据
      queryTable(qryAreaStockReport, param).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        } else {
          changeTab(tabIndex.value)
        }
      });
    };
    const param: ComposeTableDetailParam = {
      queryFn: queryTableAction, // 查询表格数据
      tableName: 'table_pcweb_warehouse_report', // 表头key
      menuType: EnumRouterName.inventory_report_warehouse, // 当前tab页对应的code
    };
    const {
      columns,
      updateColumn, //  表头数据
      columnsDetail,
      registerColumnDetail,
      detailTableList, // 明细表头数据
      expandedRowKeys,
      selectedRow,
      rowClassName,
      Rowclick, // 表格事件
    } = handleComposeTable_detail<Ermcp3AreaStockReport>(param);
    const chaceSearchValue = ref<TypeAndTime>();

    // 底部明细标签
    const tabList = getTableButton();
    // 当前选中的标签
    const tabIndex = ref(0);

    // 切换明细
    function changeTab(index: number) {
      const { code, lable } = tabList[index];
      tabIndex.value = index;
      detailTableList.value = [];
      visible.value = true;

      if (code === 'warehouse_report_warehouse_detail') {
        // 库存明细
        // 注册表头
        registerColumnDetail('table_pcweb_inventory_warehouse_report_warehouse_details');
      } else {
        console.error(`${lable}没有配置对应的code: ${code},`);
        return;
      }

      if (selectedRow.value) {
        const data = selectedRow.value as Ermcp3AreaStockReport;
        const { cycletype, deliverygoodsid, wrstandardid, spotgoodsbrandid, warehouseinfoid } = data;
        const param: AreaStockReportReq = {
          querytype: 2,
          cycletype,
          cycletime,
          sumfields: '1,2,3,4',
          deliverygoodsid,
          wrstandardid,
          spotgoodsbrandid,
          warehouseinfoid,
          userid: chaceSearchValue.value?.userid,
        };
        // 查询明细数据
        queryResultLoadingAndInfo(qryAreaStockReport, loading, param).then((res) => {
          detailTableList.value = res;
        });
      }
    }

    function search(value: TypeAndTime) {
      detailTableList.value = [];
      chaceSearchValue.value = value;
      cycletime = value.cycletime;
      const obj = Object.assign(value, { querytype: 1, sumfields: '1,2,4' });
      queryTable(qryAreaStockReport, obj).then((res) => {
        if (res.length) {
          selectedRow.value = res[0];
        }
      });
    }

    watch(selectedRow, () => changeTab(tabIndex.value))

    return { loading, tableList, visible, columns, updateColumn, search, columnsDetail, detailTableList, expandedRowKeys, selectedRow, rowClassName, Rowclick, tabList, changeTab };
  },
});
</script>